Subject: Re: [MAINTAINERS SUMMIT] Device Passthrough Considered Harmful?

From: Jason Gunthorpe <[email-masked]>
Date: Thu, 11 Jul 2024 11:07:52 -0300

On Tue, Jul 09, 2024 at 03:47:23PM +0300, Leon Romanovsky wrote:
> On Tue, Jul 09, 2024 at 02:33:17PM +0200, Greg KH wrote:
> > On Tue, Jul 09, 2024 at 03:25:47PM +0300, Leon Romanovsky wrote:
> > > On Tue, Jul 09, 2024 at 12:01:06PM +0200, Greg KH wrote:
> > > > On Mon, Jul 08, 2024 at 03:26:43PM -0700, Dan Williams wrote:
> > > 
> > > <...>
> > > 
> > > > > It sets common expectations for
> > > > > device designers, distribution maintainers, and kernel developers. It is
> > > > > complimentary to the Linux-command path for operations that need deeper
> > > > > kernel coordination.
> > > > 
> > > > Yes, it's a good start, BUT by circumventing the network control plane,
> > > > the network driver maintainers rightfully are worried about this as
> > > > their review comments seem to be ignored here.  The rest of us
> > > > maintainers can't ignore that objection, sorry.
> > > 
> > > Can you please point to the TECHNICAL review comments that were
> > > presented and later ignored?
> > 
> > I can't remember review comments that were made yesterday, let alone
> > months ago, sorry.
> 
> So I will summarize the situation for you. There are NO technical review
> comments from netdev maintainer (not plural maintainers). The difference
> is philosophical and not technical.

Yes, to my knowledge no technical comments where given against fwctl
that have not been addressed.

Also, please, can we understand that networking in Linux has diverse
maintainership?

These days a huge amount of networking hardware is being deployed
where the software netdev networking stack is not the primary software
driving the HW. Many sites principally use RDMA, DPDK, and other
stacks on some devices.

For instance I previously shared a paper from Azure indicating that
over 70% of traffic on some of their networks was RDMA focused. [1]

We need to *share* the responsibility to support this complex HW. I'm
certain we won't always agree on the right way to do that.

If there is no real technical harm, let's not leap to vetoing ideas
from other networking-related subsystem maintainers please.

Jason

[1] https://www.usenix.org/system/files/nsdi23-bai.pdf